[flashrom] [PATCH] Add utility to print all chip names in flashchips.h that are not in flashchips.c.

Stefan Tauner stefan.tauner at student.tuwien.ac.at
Fri Feb 22 21:51:27 CET 2013


This allows to list yet unsupported chips easily.

First it tries to find the directory containing the files, then it uses sed to
extract the macro names of chips from flashchips.h, greps for them in
flashchips.c and prints it if it is not found.
If verbose mode is activated by giving at least one additional parameter
it prints the comment following the macro definition too.

Signed-off-by: Stefan Tauner <stefan.tauner at student.tuwien.ac.at>
---
 util/list_yet_unsupported_chips.sh |   22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)
 create mode 100755 util/list_yet_unsupported_chips.sh

diff --git a/util/list_yet_unsupported_chips.sh b/util/list_yet_unsupported_chips.sh
new file mode 100755
index 0000000..2ed71e6
--- /dev/null
+++ b/util/list_yet_unsupported_chips.sh
@@ -0,0 +1,22 @@
+#!/bin/sh
+
+path="$(dirname $(readlink -f $0))/.."
+if [ ! -e "$path/flashchips.c" -o ! -e "$path/flashchips.h" ]; then
+	echo "Warning: could not calculate flashchips.[ch]'s directory. Trying current..."
+	path="."
+	if [ ! -e "$path/flashchips.c" -o ! -e "$path/flashchips.h" ]; then
+		echo "Nope, sorry!"
+		exit 1
+	fi
+fi
+
+chips=`sed -re '/#define [A-Z]/ !d' -e '/_ID\s/d' -e 's/\s*#define\s+([[:alnum:]_]+)\s+.*/\1/' $path/flashchips.h`
+for c in $chips ; do
+	if ! grep "$c" "$path/flashchips.c" >/dev/null ; then
+		if [ -n "$1" ]; then
+			grep -o "$c.*" "$path/flashchips.h"
+		else
+			echo "$c"
+		fi
+	fi
+done
-- 
Kind regards, Stefan Tauner





More information about the flashrom mailing list